#include "pedo_main.h"

#if defined(_EN_IAP_TREATY_01)
    #include "iapTreaty01.h"
#elif defined(_EN_IAP_TREATY_02)
    #include "iapTreaty02.h"
#endif

#undef _DISABLE_BOND

#define _DISABLE_NRF_PAC 1

NrfPacHal_t     gNrfPacHal;
NrfPacInteface_t *gNrfPac = NULL;


static void nrf_pac_gap_params_init(void *me)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;    
    uint32_t                err_code;
    ble_gap_conn_params_t   gap_conn_params;
    ble_gap_conn_sec_mode_t sec_mode;

    PERSON_INFO PersonInfo;
    uint8_t length;
    uint8_t  mDevName[20];
    
    BLE_GAP_CONN_SEC_MODE_SET_OPEN(&sec_mode);

    memset(&PersonInfo, 0, sizeof(PERSON_INFO));
    if(NVRAM_OBJECT_INTERFACE(gNvRam,Read)(gNvRam, PERSON_INFORMATION_ADDRESS,(uint8_t *)(&PersonInfo),sizeof(PERSON_INFO)) == FALSE)
    {
	
    }
    
    if((Crc16((uint8_t *)(&PersonInfo) + PERSON_INFORMATION_START_OFFSET_CRC, sizeof(PERSON_INFO) - PERSON_INFORMATION_END_OFFSET_CRC) == PersonInfo.m_CrcValue) &&
        (PersonInfo.m_CrcValue != 0x0000) && (PersonInfo.m_CrcValue != 0xffff)&&
        (PersonInfo.m_name[0] != 0x00) &&(PersonInfo.m_name[0] != 0xFF))
    {
        length = 10;
        memcpy(mDevName, PersonInfo.m_name, length);
    }
    else
    {
        length = strlen(DEVICE_NAME);
        memcpy(mDevName, DEVICE_NAME, length);
    }   

    
    err_code = sd_ble_gap_device_name_set(&sec_mode, (const uint8_t *)mDevName, length);
    
    APP_ERROR_CHECK(err_code);
#if !defined(_DISABLE_BOND)
    //inkfish BLE_APPEARANCE_GENERIC_KEYRING Ҫݾ豸ãHIDõBLE_APPEARANCE_HID_MOUSE
    err_code = sd_ble_gap_appearance_set(BLE_APPEARANCE_GENERIC_KEYRING);
    APP_ERROR_CHECK(err_code);
#endif	
    memset(&gap_conn_params, 0, sizeof(gap_conn_params));

    gap_conn_params.min_conn_interval = MIN_CONN_INTERVAL;
    gap_conn_params.max_conn_interval = MAX_CONN_INTERVAL;
    gap_conn_params.slave_latency     = SLAVE_LATENCY;
    gap_conn_params.conn_sup_timeout  = CONN_SUP_TIMEOUT;

    err_code = sd_ble_gap_ppcp_set(&gap_conn_params);
    APP_ERROR_CHECK(err_code);
		
    err_code = sd_ble_gap_tx_power_set(TX_POWER_LEVEL);
    APP_ERROR_CHECK(err_code);		

    pNrfPacHal->mIoSpeed = IO_STATE_LOWPOWER_DISABLE;
}



static void nrf_pac_advertising_init(void *me, uint8_t advflags)
{
    uint32_t      err_code;
    ble_advdata_t advdata;
    ble_advdata_t scanrsp;
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    
    int8_t        tx_power_level = TX_POWER_LEVEL;
    
    ble_uuid_t pac_adv_uuids[4]=
    {
        {BLE_UUID_TX_POWER_SERVICE,        BLE_UUID_TYPE_BLE},
        {BLE_UUID_IMMEDIATE_ALERT_SERVICE, BLE_UUID_TYPE_BLE},
        {BLE_UUID_LINK_LOSS_SERVICE,       BLE_UUID_TYPE_BLE},
        {BLE_UUID_PAC_SERVICE,             BLE_UUID_TYPE_VENDOR_BEGIN}            
    };
        
    //һҪ
    memset(&advdata, 0, sizeof(advdata));
    
    pNrfPacHal->mAdvertisingMode = PEDO_BLE_NO_ADV;

    //pac_adv_uuids[3].uuid = BLE_UUID_PAC_SERVICE;
    //pac_adv_uuids[3].type = pNrfPacHal->mPac.uuid_type;	


    advdata.name_type               = BLE_ADVDATA_SHORT_NAME;
    advdata.short_name_len          = 6;//ָƳ
    advdata.include_appearance      = true;
    advdata.flags.size              = sizeof(advflags);
    advdata.flags.p_data            = &advflags;
    advdata.p_tx_power_level        = &tx_power_level;
    advdata.uuids_complete.uuid_cnt = 3;//sizeof(pac_adv_uuids) / sizeof(pac_adv_uuids[0]);
    advdata.uuids_complete.p_uuids  = &pac_adv_uuids[0];
    
    //0x0Cʾ㲥ݽʱȣ豸
    err_code = ble_advdata_set(&advdata, NULL);
    APP_ERROR_CHECK(err_code);    
    
    //memset(&scanrsp, 0, sizeof(scanrsp));
    //scanrsp.uuids_complete.uuid_cnt = 1;
    //scanrsp.uuids_complete.p_uuids  = &pac_adv_uuids[3];
    
    //err_code = ble_advdata_set(&advdata, &scanrsp);
    //APP_ERROR_CHECK(err_code);

/*
    pac_adv_uuids[0].uuid = BLE_UUID_PAC_SERVICE;
    pac_adv_uuids[0].type = pNrfPacHal->mPac.uuid_type;		
        
    memset(&advdata, 0, sizeof(advdata));
    advdata.name_type               = BLE_ADVDATA_FULL_NAME;
    advdata.include_appearance      = false;
    advdata.flags.size              = sizeof(advflags);
    advdata.flags.p_data            = &advflags;

    memset(&scanrsp, 0, sizeof(scanrsp));
    scanrsp.uuids_complete.uuid_cnt = 1;
    scanrsp.uuids_complete.p_uuids  = pac_adv_uuids;
    
    err_code = ble_advdata_set(&advdata, &scanrsp);
    APP_ERROR_CHECK(err_code);

*/
}


void nrf_uart_tx_data_handler(void *me, ble_pac_t * p_pac, uint8_t * data, uint16_t length)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    uint8_t *Receive_Buffer = (uint8_t *)(IAP_RECEIVE_BUFFER_ADDRESS);

    if(pNrfPacHal == NULL) return;
    

    memcpy((Receive_Buffer + pNrfPacHal->mReceiveLength), data, length);
    
    if(pNrfPacHal->mReceiveState == RECEIVE_PACK_END)
    {
        TRACE_INFO1("NRF PAC Receive Overflow");
        TRACE_INFO2("RTC second = %x", RTC_OBJECT_INTERFACE(gRtc,GetSecond32)(gRtc));
    }
   	if(pNrfPacHal->mReceiveState == RECEIVE_PACK_HEAD_1)
   	{	  
    #if (PACK_HEAD_LENGTH == 2)
        if(Buffer_Get_Half_Word(Receive_Buffer, PACK_HEAD_1_FIELD) == PACK_HEAD_FLAG)
    #elif (PACK_HEAD_LENGTH == 1)
        if(Receive_Buffer[PACK_HEAD_1_FIELD] == PACK_HEAD_FLAG)
    #endif
   	     {
   	        TRACE1("NRF PAC RECEIVE PACK_HEAD"); 
        #if (PACK_LEN_LENGTH == 2)
            pNrfPacHal->mPackLength = Buffer_Get_Half_Word(Receive_Buffer, PACK_LENGTH_1_FIELD);
        #elif (PACK_LEN_LENGTH == 1)
            pNrfPacHal->mPackLength = Buffer_Get_Byte(Receive_Buffer, PACK_LENGTH_1_FIELD);        
        #endif
            pNrfPacHal->mPackLength  += PACK_HEAD_LENGTH + PACK_LEN_LENGTH;	 
            pNrfPacHal->mReceiveState = RECEIVE_PACK_LOAD;
            
            ApplyUpdateRtcWakeupPeriod(WAKEUP_RTC_CHANGE_FROM_PAC_TIMEOUT, SYSTEM_RTC_PAC_TIME_OUT_CHECK_PERIOD);
					  //TRACE_INFO2("#:=%d", pNrfPacHal->mPackLength);
         }
         else
         {
            TRACE_ERROR1("NRF PAC PACK_HEAD_ERROR"); 
            return;
         }
         //Ҫϰճʱ
   	}
   	pNrfPacHal->mReceiveLength += length;
		
   	if(pNrfPacHal->mReceiveLength >= pNrfPacHal->mPackLength)
   	{
   	   	pNrfPacHal->mReceiveState = RECEIVE_PACK_END;
        pNrfPacHal->mReceiveLength = 0;
        ApplyUpdateRtcWakeupPeriod(WAKEUP_RTC_CHANGE_FROM_PAC_TIMEOUT, SYSTEM_RTC_LOWPOWER_WAKEUP_PERIOD);
   	}
    //if(gIapInterface != NULL)
    //{
    //    gIapInterface->WaitIAPCommandAndProcess(gIapInterface);    
    //}
}


static void nrf_pac_services_init(void *me)
{
    uint32_t err_code;
    ble_pac_init_t pac_init;
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    
    memset(&pac_init, 0, sizeof(pac_init));
    pac_init.data_handler = &nrf_uart_tx_data_handler;
    pac_init.p_context = me;
    
    err_code = ble_pac_init(&pNrfPacHal->mPac, &pac_init);
    APP_ERROR_CHECK(err_code);
}



static void nrf_pac_sec_params_init(void *me)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    pNrfPacHal->mSecParams.timeout      = SEC_PARAM_TIMEOUT;
    pNrfPacHal->mSecParams.bond         = SEC_PARAM_BOND;
    pNrfPacHal->mSecParams.mitm         = SEC_PARAM_MITM;
    pNrfPacHal->mSecParams.io_caps      = SEC_PARAM_IO_CAPABILITIES;
    pNrfPacHal->mSecParams.oob          = SEC_PARAM_OOB;  
    pNrfPacHal->mSecParams.min_key_size = SEC_PARAM_MIN_KEY_SIZE;
    pNrfPacHal->mSecParams.max_key_size = SEC_PARAM_MAX_KEY_SIZE;
}


/**@brief Connection Parameters Module handler.
 *
 * @details This function will be called for all events in the Connection Parameters Module which
 *          are passed to the application.
 *          @note All this function does is to disconnect. This could have been done by simply
 *                setting the disconnect_on_fail config parameter, but instead we use the event
 *                handler mechanism to demonstrate its use.
 *
 * @param[in]   p_evt   Event received from the Connection Parameters Module.
 */
static void on_conn_params_evt(ble_conn_params_evt_t * p_evt)
{
    uint32_t err_code;
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)&gNrfPacHal;
    
    if(p_evt->evt_type == BLE_CONN_PARAMS_EVT_FAILED)
    {
        err_code = sd_ble_gap_disconnect(pNrfPacHal->mConnHandle, BLE_HCI_CONN_INTERVAL_UNACCEPTABLE);
        APP_ERROR_CHECK(err_code);
    }
}


/**@brief Connection Parameters module error handler.
 *
 * @param[in]   nrf_error   Error code containing information about what went wrong.
 */
static void conn_params_error_handler(uint32_t nrf_error)
{
    APP_ERROR_HANDLER(nrf_error);
}


/**@brief Initialize the Connection Parameters module.
 */
static void nrf_pac_conn_params_init(void *me)
{
    uint32_t               err_code;
    ble_conn_params_init_t cp_init;
    
    //NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    memset(&cp_init, 0, sizeof(cp_init));

    cp_init.p_conn_params                  = NULL;
    cp_init.first_conn_params_update_delay = FIRST_CONN_PARAMS_UPDATE_DELAY;
    cp_init.next_conn_params_update_delay  = NEXT_CONN_PARAMS_UPDATE_DELAY;
    cp_init.max_conn_params_update_count   = MAX_CONN_PARAMS_UPDATE_COUNT;
    cp_init.start_on_notify_cccd_handle    = BLE_GATT_HANDLE_INVALID;
    cp_init.disconnect_on_fail           = false;
    cp_init.evt_handler                 = on_conn_params_evt;
    cp_init.error_handler               = conn_params_error_handler;
	
    err_code = ble_conn_params_init(&cp_init);
    APP_ERROR_CHECK(err_code);
}




void nrf_pac_advertising_start(void *me)
{
    uint32_t             err_code;
    ble_gap_adv_params_t adv_params;
#if !defined(_DISABLE_BOND)	
    ble_gap_whitelist_t  whitelist;
    ble_gap_addr_t       peer_address;
#endif
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    

    // Initialize advertising parameters with defaults values
    memset(&adv_params, 0, sizeof(adv_params));
    
    adv_params.type        = BLE_GAP_ADV_TYPE_ADV_IND;
    adv_params.p_peer_addr = NULL;
    adv_params.fp          = BLE_GAP_ADV_FP_ANY;
    adv_params.p_whitelist = NULL;
    
    // Configure advertisement according to current advertising state
#if !defined(_DISABLE_BOND)	  
    if (pNrfPacHal->mAdvertisingMode == PEDO_BLE_DIRECTED_ADV)
    {
        err_code = ble_bondmngr_master_addr_get(pNrfPacHal->mLastConnectedMaster, 
                                                                    &peer_address);
        if (err_code != NRF_SUCCESS)
        {
            pNrfPacHal->mAdvertisingMode = PEDO_BLE_FAST_ADV_WHITELIST;
        }
    }
#endif    
      
    switch (pNrfPacHal->mAdvertisingMode)
    {
        case PEDO_BLE_NO_ADV:
    #if defined(_DISABLE_BOND)	
            pNrfPacHal->mAdvertisingMode = PEDO_BLE_FAST_ADV;
            // fall through.
    #else
            pNrfPacHal->mAdvertisingMode = PEDO_BLE_FAST_ADV_WHITELIST;
            // fall through.

        case PEDO_BLE_FAST_ADV_WHITELIST:
            err_code = ble_bondmngr_whitelist_get(&whitelist);
            APP_ERROR_CHECK(err_code); 

            if ((whitelist.addr_count != 0) || (whitelist.irk_count != 0))
            {
                adv_params.fp          = BLE_GAP_ADV_FP_FILTER_CONNREQ;
                adv_params.p_whitelist = &whitelist;
                
                nrf_pac_advertising_init(me, BLE_GAP_ADV_FLAG_BR_EDR_NOT_SUPPORTED);
                pNrfPacHal->mAdvertisingMode = PEDO_BLE_FAST_ADV;
                //nrf_gpio_pin_set(ADV_WHITELIST_LED_PIN_NO);
            }
            else
            {
                pNrfPacHal->mAdvertisingMode = PEDO_BLE_SLOW_ADV;           
            }
            
            adv_params.interval = APP_ADV_INTERVAL_FAST;
            adv_params.timeout  = APP_FAST_ADV_WHITELIST_TIMEOUT;
            break;
            
        case PEDO_BLE_DIRECTED_ADV:
            adv_params.p_peer_addr = &peer_address;
            adv_params.type        = BLE_GAP_ADV_TYPE_ADV_DIRECT_IND;
            adv_params.timeout     = 0;
            
            pNrfPacHal->mDirectAdvCnt--;
            if (pNrfPacHal->mDirectAdvCnt == 0)
            {
                pNrfPacHal->mAdvertisingMode = PEDO_BLE_FAST_ADV_WHITELIST;
            }
            //nrf_gpio_pin_set(ADV_DIRECTED_LED_PIN_NO);      
            break;
    #endif            
        case PEDO_BLE_FAST_ADV:
            TRACE_INFO1("PEDO_BLE_FAST_ADV");
            nrf_pac_advertising_init(me, BLE_GAP_ADV_FLAGS_LE_ONLY_LIMITED_DISC_MODE);
            
            adv_params.interval = APP_ADV_INTERVAL_FAST;
            adv_params.timeout  = APP_FAST_ADV_TIMEOUT;
            pNrfPacHal->mAdvertisingMode  = PEDO_BLE_SLOW_ADV;            
            break;
            
        case PEDO_BLE_SLOW_ADV:
            TRACE_INFO1("PEDO_BLE_SLOW_ADV");
            nrf_pac_advertising_init(me, BLE_GAP_ADV_FLAGS_LE_ONLY_LIMITED_DISC_MODE);
            
            adv_params.interval = APP_ADV_INTERVAL_SLOW;
            adv_params.timeout  = APP_SLOW_ADV_TIMEOUT;
            pNrfPacHal->mAdvertisingMode  = PEDO_BLE_SLOW_ADV;
            break;
            
        default:
            break;
    }

    // Start advertising.
    err_code = sd_ble_gap_adv_start(&adv_params);
    APP_ERROR_CHECK(err_code);
    
    //nrf_gpio_pin_set(ADVERTISING_LED_PIN_NO);
}


static void on_ble_evt(void *me, ble_evt_t * p_ble_evt)
{
    uint32_t                         err_code = NRF_SUCCESS;
    static ble_gap_evt_auth_status_t m_auth_status;
    ble_gap_enc_info_t *             p_enc_info;
    //STR_PARAM strParam;   
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    NrfPacInteface_t *mInterface = (NrfPacInteface_t *)pNrfPacHal;	
    
    
    switch (p_ble_evt->header.evt_id)
    {
        case BLE_GAP_EVT_CONNECTED:
            TRACE_INFO1("NRF PAC CONNECTED");

            pNrfPacHal->mConnHandle = p_ble_evt->evt.gap_evt.conn_handle;

            mInterface->SetIoState(mInterface,IO_STATE_CONNECTED);  

            pNrfPacHal->mAdvertisingMode = PEDO_BLE_NO_ADV;
            
            break;
            
        case BLE_GAP_EVT_DISCONNECTED:
            TRACE_INFO1("NRF PAC DISCONNECTED");
            //strParam.str = "disconnected...   ";
            //LCD_OBJECT_INTERFACE(gLcd,_DisplayString)(gLcd, &strParam);
            //nrf_gpio_pin_clear(CONNECTED_LED_PIN_NO);
            pNrfPacHal->mConnHandle = BLE_CONN_HANDLE_INVALID;
            
            mInterface->SetIoState(mInterface,IO_STATE_DISCONNECT); 
        #if defined(_DISABLE_BOND)	
            pNrfPacHal->mAdvertisingMode = PEDO_BLE_FAST_ADV;
        #else
            err_code = ble_bondmngr_bonded_masters_store();
            APP_ERROR_CHECK(err_code);
            pNrfPacHal->mAdvertisingMode = PEDO_BLE_DIRECTED_ADV;
        #endif
            pNrfPacHal->mDirectAdvCnt   = APP_DIRECTED_ADV_TIMEOUT;
            nrf_pac_advertising_start(me);

            break;
           
        case BLE_GAP_EVT_SEC_PARAMS_REQUEST:
            err_code = sd_ble_gap_sec_params_reply(pNrfPacHal->mConnHandle, 
                                                   BLE_GAP_SEC_STATUS_SUCCESS, 
                                                   &pNrfPacHal->mSecParams);
            break;
            
        case BLE_GATTS_EVT_SYS_ATTR_MISSING:
            err_code = sd_ble_gatts_sys_attr_set(pNrfPacHal->mConnHandle, NULL, 0);
            break;

        case BLE_GAP_EVT_AUTH_STATUS:
            m_auth_status = p_ble_evt->evt.gap_evt.params.auth_status;
            break;
            
        case BLE_GAP_EVT_SEC_INFO_REQUEST:
            p_enc_info = &m_auth_status.periph_keys.enc_info;
            if (p_enc_info->div == p_ble_evt->evt.gap_evt.params.sec_info_request.div)
            {
                err_code = sd_ble_gap_sec_info_reply(pNrfPacHal->mConnHandle, p_enc_info, NULL);
            }
            else
            {
                // No keys found for this device
                err_code = sd_ble_gap_sec_info_reply(pNrfPacHal->mConnHandle, NULL, NULL);
            }
            break;

        case BLE_GAP_EVT_TIMEOUT:
            if (p_ble_evt->evt.gap_evt.params.timeout.src == BLE_GAP_TIMEOUT_SRC_ADVERTISEMENT)
            { 
                TRACE_INFO1("NRF PAC BLE_GAP_EVT_TIMEOUT");
                //if(pNrfPacHal->mAdvertisingMode == PEDO_BLE_SLEEP)
                //{
                //    pNrfPacHal->mAdvertisingMode = PEDO_BLE_NO_ADV;
                //    mInterface->SetIoState(mInterface,IO_STATE_CLOSED); 
                    //err_code = sd_power_system_off();    
                //}
                //else
                {
                      //ı㲥ģʽnrf_pac_advertising_start
                      //pNrfPacHal->mAdvertisingMode = PEDO_BLE_SLOW_ADV;
                      nrf_pac_advertising_start(me);
                }

            }

            break;
            
        case BLE_GATTC_EVT_TIMEOUT:
        case BLE_GATTS_EVT_TIMEOUT:
            // Disconnect on GATT Server and Client timeout events.
            err_code = sd_ble_gap_disconnect(pNrfPacHal->mConnHandle, BLE_HCI_REMOTE_USER_TERMINATED_CONNECTION);
            break;

        default:
            break;
    }

    APP_ERROR_CHECK(err_code);
}



static void ble_evt_dispatch(ble_evt_t * p_ble_evt)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)&gNrfPacHal;
    
#if !defined(_DISABLE_BOND)  
    ble_bondmngr_on_ble_evt(p_ble_evt);
#endif	
    ble_conn_params_on_ble_evt(p_ble_evt);
#if !defined(_DISABLE_NRF_PAC)
    ble_pac_on_ble_evt(&pNrfPacHal->mPac, p_ble_evt);
#endif
#if !defined(_DISABLE_PROXIMITY_SERVICE)
    ble_ias_on_ble_evt(&pNrfPacHal->mIas, p_ble_evt);
    ble_lls_on_ble_evt(&pNrfPacHal->mLls, p_ble_evt);
    ble_ias_c_on_ble_evt(&pNrfPacHal->mIasC, p_ble_evt);
#endif  

    on_ble_evt(pNrfPacHal, p_ble_evt);
}



static void nrf_pac_ble_stack_init(void *me)
{
    BLE_STACK_HANDLER_INIT(NRF_CLOCK_LFCLKSRC_XTAL_20_PPM,
                           BLE_L2CAP_MTU_DEF,
                           ble_evt_dispatch,
                           false);	
}

void NRF_PAC_IAP_IO_SEND(void *me, uint8_t *buf, uint16_t length)
{
#if !defined(_DISABLE_NRF_PAC)
    uint32_t err_code;
    uint32_t CurrentSendLength = 0;
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    uint16_t lengthBack = length;
	
    //TRACE_INFO2("NRF_PAC_IAP_IO_SEND length = %d", length);
    //TRACEnHex_INFO(buf, length);
    while(length > 0)
    {
			
        if(length > PAC_MAX_DATA_LENGTH)
        {
            CurrentSendLength = PAC_MAX_DATA_LENGTH;
            length -= PAC_MAX_DATA_LENGTH;
        }
        else
        {
            CurrentSendLength = length;
            length = 0;
        }
        //while(1)
        {
            err_code = ble_pac_uart_send_string(&pNrfPacHal->mPac, buf, CurrentSendLength);

            if (err_code != NRF_ERROR_INVALID_STATE)
            {
                APP_ERROR_CHECK(err_code);
            }
            if(err_code == BLE_ERROR_NO_TX_BUFFERS)
            {
                TRACE_ERROR2("NRF_PAC_IAP_IO_SEND length = %d", length);
                //delay_ms(10);
                //IWDG_FEED;
            }
            else 
            {
                ;//break;
            }
        }			
        buf += CurrentSendLength;
    }
    if(lengthBack <= PAC_MAX_DATA_LENGTH)
    {
        uint8_t Tbuf[PAC_MAX_DATA_LENGTH];
        memset(Tbuf, 0, PAC_MAX_DATA_LENGTH);

        err_code = ble_pac_uart_send_string(&pNrfPacHal->mPac, Tbuf, PAC_MAX_DATA_LENGTH);

        if (err_code != NRF_ERROR_INVALID_STATE)
        {
            APP_ERROR_CHECK(err_code);
        }
        
    }
#endif    
}
void SET_NRF_PAC_IO_STATE(void *me,IAP_IO_STATE state)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    uint32_t errCode;
    ble_gap_conn_params_t mNewParam;
	
    switch(state)
    {
        case IO_STATE_OPEN:
            if(pNrfPacHal->mIoState == IO_STATE_CLOSED)
            {
                //gBleStackHanlerInterface->StackReStart(gBleStackHanlerInterface);
                //errCode = gBleConnParamsInterface->bleConnParamsRestart(gBleConnParamsInterface);
                //APP_ERROR_CHECK(errCode);            
                state = IO_STATE_OPEN;
            }
            break;
        case IO_STATE_START_ADVERTISING:
            if(pNrfPacHal->mIoState == IO_STATE_CLOSED)
            {
                nrf_pac_advertising_start(me);
                state = IO_STATE_ADVERTISING;
            }
            break;
        case IO_STATE_SEND_CONNECT_REQUEST:
            break;
            
        case IO_STATE_CONNECTED:

        case IO_STATE_DISCONNECT:
        #if !defined(_DISABLE_CAMERA_SERVICE) 
            pNrfPacHal->mCameraOpenEnable = FALSE;
        #endif
            pNrfPacHal->mReceiveState = RECEIVE_PACK_HEAD_1;
            pNrfPacHal->mReceiveTimoutRecord = 0;
            pNrfPacHal->mReceiveLength = 0;
            break;
        case IO_STATE_CLOSED:
            if(pNrfPacHal->mIoState == IO_STATE_CLOSED)
                return;
            TRACE_INFO1("CLOSE_NRF_PAC_IAP_IO");
            errCode = ble_conn_params_stop();
            APP_ERROR_CHECK(errCode);
            errCode = sd_softdevice_disable();
            APP_ERROR_CHECK(errCode);
            break;
        case IO_STATE_LOWPOWER_ENABLE:
   
            if(pNrfPacHal->mIoState != IO_STATE_CONNECTED)
                return;
            if(pNrfPacHal->mIoSpeed != IO_STATE_LOWPOWER_ENABLE)
            {
                mNewParam.min_conn_interval = LOWPOWER_MIN_CONN_INTERVAL;
                mNewParam.max_conn_interval = LOWPOWER_MAX_CONN_INTERVAL;
                mNewParam.slave_latency     = LOWPOWER_SLAVE_LATENCY;
                mNewParam.conn_sup_timeout  = LOWPOWER_CONN_SUP_TIMEOUT;
            
                errCode = ble_conn_params_change_conn_params(&mNewParam);
                APP_ERROR_CHECK(errCode);
                pNrfPacHal->mIoSpeed = IO_STATE_LOWPOWER_ENABLE;
            }
          
            return;
        case IO_STATE_LOWPOWER_DISABLE:
           
            if(pNrfPacHal->mIoState != IO_STATE_CONNECTED)
                return;   
            if(pNrfPacHal->mIoSpeed != IO_STATE_LOWPOWER_DISABLE)
            {
                mNewParam.min_conn_interval = MIN_CONN_INTERVAL;
                mNewParam.max_conn_interval = MAX_CONN_INTERVAL;
                mNewParam.slave_latency     = SLAVE_LATENCY;
                mNewParam.conn_sup_timeout  = CONN_SUP_TIMEOUT;
            
                errCode = ble_conn_params_change_conn_params(&mNewParam);
                APP_ERROR_CHECK(errCode);
                pNrfPacHal->mIoSpeed = IO_STATE_LOWPOWER_DISABLE;
            }
           
            return;
    }

    //err_code = sd_softdevice_disable();
    //APP_ERROR_CHECK(err_code);
    pNrfPacHal->mIoState  = state;
}

IAP_RECEIVE_STATE GET_NRF_PAC_IAP_RECEIVE_STATE(void *me)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    return pNrfPacHal->mReceiveState;
}

void CLEAR_NRF_PAC_IAP_RECEIVE_STATE(void *me)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    pNrfPacHal->mReceiveState = RECEIVE_PACK_HEAD_1;
}


IAP_IO_STATE NRF_GET_PAC_IO_STATE(void *me)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    return pNrfPacHal->mIoState;    
}

IAP_HOST_TYPE NRF_PAC_IO_TYPE(void *me)
{
    return IAP_HOST_NRF_UART;
}

void NRF_PAC_IO_TimeOutProcess(void *me)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;

    if(pNrfPacHal->mReceiveState == RECEIVE_PACK_LOAD)
    {
        if(++pNrfPacHal->mReceiveTimoutRecord > 4)
        {
            TRACE_ERROR1("NRF PAC IO TIME OUT");
            pNrfPacHal->mReceiveState = RECEIVE_PACK_HEAD_1;
            pNrfPacHal->mReceiveTimoutRecord = 0;
            pNrfPacHal->mReceiveLength = 0;
            ApplyUpdateRtcWakeupPeriod(WAKEUP_RTC_CHANGE_FROM_PAC_TIMEOUT, SYSTEM_RTC_LOWPOWER_WAKEUP_PERIOD);
        }
    }
    else
    {
        pNrfPacHal->mReceiveTimoutRecord = 0;
    }    
}


static void NRF_PAC_IO_BOND_MANAGER_ERROR_HANLDER(uint32_t nrf_error)
{
    APP_ERROR_HANDLER(nrf_error);
}

static void NRF_PAC_IO_BOND_EVT_HANDLER(ble_bondmngr_evt_t * p_evt)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)&gNrfPacHal;
    pNrfPacHal->mLastConnectedMaster = p_evt->master_handle;
}

void gNrfPacUpdatePedometerDatas(void *me, uint32_t steps, uint32_t distance, uint32_t calors)
{
#if !defined(_DISABLE_CAMERA_SERVICE)      
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;

    pNrfPacHal->mSteps = steps;
    pNrfPacHal->mDistance = distance;
    pNrfPacHal->mCalors = calors;

    if(++pNrfPacHal->mPedoUpdateCount >= 10)
    {
        pNrfPacHal->mPedoUpdateCount = 0;
        pNrfPacHal->mUpdateMark = TRUE;
    }
#endif
}

void gNrfPacUpdateCameraState(void *me, uint8_t openEn)
{
#if !defined(_DISABLE_CAMERA_SERVICE)      
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;

    pNrfPacHal->mCameraOpenEnable = openEn;
    pNrfPacHal->mUpdateMark = TRUE;
#endif    
}

void gNrfPacSendNotify(void *me)
{
#if !defined(_DISABLE_CAMERA_SERVICE)      
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    uint32_t err_code;
    uint8_t buf[PAC_MAX_DATA_LENGTH];
    uint8_t off = 0;

    if(pNrfPacHal->mUpdateMark == TRUE)
    {
        if(pNrfPacHal->mCameraTouch == 0x00)
        {
            pNrfPacHal->mUpdateMark = FALSE;
        }
        memset(buf, 0, sizeof(buf));
    
        Buffer_Write_Word(pNrfPacHal->mSteps, &buf[off]);
        off+= sizeof(pNrfPacHal->mSteps);

        Buffer_Write_Word(pNrfPacHal->mDistance, &buf[off]);
        off+= sizeof(pNrfPacHal->mDistance);

        Buffer_Write_Word(pNrfPacHal->mCalors, &buf[off]);
        off+= sizeof(pNrfPacHal->mCalors);

        buf[off] = pNrfPacHal->mCameraOpenEnable;
        off+= sizeof(pNrfPacHal->mCameraOpenEnable);

        buf[off] = pNrfPacHal->mCameraTouch;

        pNrfPacHal->mCameraTouch = 0x00;
       
        err_code = ble_pac_send_string(&pNrfPacHal->mPac, buf, PAC_MAX_DATA_LENGTH);
    
        if (err_code != NRF_ERROR_INVALID_STATE)
        {
                APP_ERROR_CHECK(err_code);
        }
    }
#endif    
}


uint8_t gNrfPacGetCameraState(void *me)
{
#if !defined(_DISABLE_CAMERA_SERVICE)      
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;

    return pNrfPacHal->mCameraOpenEnable;
#else
    return FALSE;
#endif
}

void gNrfPacTouchTheCamera(void *me)
{
#if !defined(_DISABLE_CAMERA_SERVICE)      
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;

    pNrfPacHal->mCameraTouch = CAMEAR_TOUCH_MARK_1;
    pNrfPacHal->mUpdateMark = TRUE;
#endif    
}

static void bond_manager_init(void *me)
{
    uint32_t            err_code;
    ble_bondmngr_init_t bond_init_data;
    bool                bonds_delete;
/*
    if(GPIO_READ_PIN(USERBUTTON_1_GPIO_PORT,USERBUTTON_1_GPIO_PIN) == 1)
    {
        bonds_delete = TRUE;
    }
    else
    {
        bonds_delete = FALSE;
    }
*/    
    bonds_delete = TRUE;
    
    // Initialize the Bond Manager.
    bond_init_data.flash_page_num_bond     = PEDO_FLASH_PAGE_BOND;
    bond_init_data.flash_page_num_sys_attr  = PEDO_FLASH_PAGE_SYS_ATTR;
    bond_init_data.evt_handler           = NRF_PAC_IO_BOND_EVT_HANDLER;
    bond_init_data.error_handler         = NRF_PAC_IO_BOND_MANAGER_ERROR_HANLDER;
    bond_init_data.bonds_delete          = bonds_delete;


    TRACE_INFO2("bond_init_data.flash_page_num_bond = %d", bond_init_data.flash_page_num_bond);
    
    err_code = ble_bondmngr_init(&bond_init_data);

    APP_ERROR_CHECK(err_code);
}

static void radio_notification_init(void *me)
{
    uint32_t err_code;

    err_code = ble_radio_notification_init(NRF_APP_PRIORITY_HIGH,
                                           NRF_RADIO_NOTIFICATION_DISTANCE_4560US,
                                           ble_flash_on_radio_active_evt);
    APP_ERROR_CHECK(err_code);    
}


static void service_error_handler(uint32_t nrf_error)
{
    ASSERT(false);
}


#if !defined(_DISABLE_PROXIMITY_SERVICE)
static void tps_init(void *me)
{
    uint32_t       err_code;
    ble_tps_init_t tps_init_obj;
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;

    memset(&tps_init_obj, 0, sizeof(tps_init_obj));
    tps_init_obj.initial_tx_power_level = TX_POWER_LEVEL;
#if !defined(_DISABLE_BOND)   
    BLE_GAP_CONN_SEC_MODE_SET_ENC_NO_MITM(&tps_init_obj.tps_attr_md.read_perm);
    BLE_GAP_CONN_SEC_MODE_SET_NO_ACCESS(&tps_init_obj.tps_attr_md.write_perm);
#else
    BLE_GAP_CONN_SEC_MODE_SET_OPEN(&tps_init_obj.tps_attr_md.read_perm);
    BLE_GAP_CONN_SEC_MODE_SET_OPEN(&tps_init_obj.tps_attr_md.write_perm);
#endif
    err_code = ble_tps_init(&pNrfPacHal->mTps, &tps_init_obj);
    APP_ERROR_CHECK(err_code);
}

static void alert_signal(void *p_context, uint8_t alert_level)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)p_context;
    NrfPacInteface_t *pInterface = (NrfPacInteface_t *)p_context;
    switch (alert_level)
    {
        case BLE_CHAR_ALERT_LEVEL_NO_ALERT:
            pNrfPacHal->mIsLinkLossAlerting = false;        
            TRACE_INFO1("BLE_CHAR_ALERT_LEVEL_NO_ALERT");
            break;

        case BLE_CHAR_ALERT_LEVEL_MILD_ALERT:
            TRACE_INFO1("BLE_CHAR_ALERT_LEVEL_MILD_ALERT");
            break;

        case BLE_CHAR_ALERT_LEVEL_HIGH_ALERT:
            TRACE_INFO1("BLE_CHAR_ALERT_LEVEL_HIGH_ALERT");
            break;
            
        default:
            break;
    }
    PAC_OBJECT_INTERFACE(pInterface,ProximityAlateProcess)(pInterface);
}

static void on_ias_evt(ble_ias_t * p_ias, ble_ias_evt_t * p_evt)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)&gNrfPacHal;
    switch (p_evt->evt_type)
    {
        case BLE_IAS_EVT_ALERT_LEVEL_UPDATED:
            pNrfPacHal->mIsLinkLossAlerting = true;
            alert_signal(pNrfPacHal, p_evt->params.alert_level);
            break;
            
        default:
            break;
    }
}

static void ias_init(void *me)
{
    uint32_t       err_code;
    ble_ias_init_t ias_init_obj;
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;

    memset(&ias_init_obj, 0, sizeof(ias_init_obj));
    ias_init_obj.evt_handler = on_ias_evt;
    
    err_code = ble_ias_init(&pNrfPacHal->mIas, &ias_init_obj);
    APP_ERROR_CHECK(err_code);
}

static void on_lls_evt(ble_lls_t * p_lls, ble_lls_evt_t * p_evt)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)&gNrfPacHal;
    switch (p_evt->evt_type)
    {
        case BLE_LLS_EVT_LINK_LOSS_ALERT:
            TRACE_INFO1("BLE_LLS_EVT_LINK_LOSS_ALERT");
            pNrfPacHal->mIsLinkLossAlerting = true;
            alert_signal(pNrfPacHal, p_evt->params.alert_level);
            break;
            
        default:
            break;
    }
}

static void lls_init(void *me)
{
    uint32_t       err_code;
    ble_lls_init_t lls_init_obj;
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    // Initialize Link Loss Service
    memset(&lls_init_obj, 0, sizeof(lls_init_obj));
    
    lls_init_obj.evt_handler         = on_lls_evt;
    lls_init_obj.error_handler       = service_error_handler;
    lls_init_obj.initial_alert_level = INITIAL_LLS_ALERT_LEVEL;
#if !defined(_DISABLE_BOND)    
    BLE_GAP_CONN_SEC_MODE_SET_ENC_NO_MITM(&lls_init_obj.lls_attr_md.read_perm);
    BLE_GAP_CONN_SEC_MODE_SET_ENC_NO_MITM(&lls_init_obj.lls_attr_md.write_perm);
#else
    BLE_GAP_CONN_SEC_MODE_SET_OPEN(&lls_init_obj.lls_attr_md.read_perm);
    BLE_GAP_CONN_SEC_MODE_SET_OPEN(&lls_init_obj.lls_attr_md.write_perm);
#endif
    err_code = ble_lls_init(&pNrfPacHal->mLls, &lls_init_obj);
    APP_ERROR_CHECK(err_code);

    pNrfPacHal->mIsLinkLossAlerting = false;
}

static void on_ias_c_evt(ble_ias_c_t * p_ias_c, ble_ias_c_evt_t * p_evt)
{
    uint32_t err_code = NRF_SUCCESS;

    switch (p_evt->evt_type)
    {
        case BLE_IAS_C_EVT_SRV_DISCOVERED:
            TRACE_INFO1("BLE_IAS_C_EVT_SRV_DISCOVERED");
            break;

        case BLE_IAS_C_EVT_SRV_NOT_FOUND:
            // IAS is not found on peer.
            break;

        case BLE_IAS_C_EVT_DISCONN_COMPLETE:
            TRACE_INFO1("BLE_IAS_C_EVT_DISCONN_COMPLETE");
            break;

        default:
            break;
    }

    APP_ERROR_CHECK(err_code);
}

static void ias_client_init(void *me)
{
    uint32_t            err_code;
    ble_ias_c_init_t    ias_c_init_obj;
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;

    memset(&ias_c_init_obj, 0, sizeof(ias_c_init_obj));

    pNrfPacHal->mIsHighAlertSignalled = false;

    ias_c_init_obj.evt_handler   = on_ias_c_evt;
    ias_c_init_obj.error_handler = service_error_handler;

    err_code = ble_ias_c_init(&pNrfPacHal->mIasC, &ias_c_init_obj);
    APP_ERROR_CHECK(err_code);
}

static void nrf_proximity_services_init(void *me)
{
    tps_init(me);
    ias_init(me);
    lls_init(me);
    ias_client_init(me);
}
#endif

uint8_t gNrfPacProximityAlateProcess(void *me)
{
    NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;

    if(pNrfPacHal->mIsLinkLossAlerting == TRUE)
    {
        TRACE_INFO1("Link Loss Alerting event");
        ApplyUpdateRtcWakeupPeriod(WAKEUP_RTC_CHANGE_FROM_LINK_LOST, SYSTEM_RTC_LINK_LOST_ALATE_PERIOD);
    }
    else
    {
        ApplyUpdateRtcWakeupPeriod(WAKEUP_RTC_CHANGE_FROM_LINK_LOST, SYSTEM_RTC_LOWPOWER_WAKEUP_PERIOD);
    }
    return pNrfPacHal->mIsLinkLossAlerting;
    
}


#if !defined(_DISABLE_DIS_SERVICE)
uint8_t nrf_pac_dis_service_init(void *me)
{
    //NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)me;
    ble_dis_init_t mDisInitParam;
    //ble_dis_sys_id_t mDisSysIdParam;
    //ble_dis_reg_cert_data_list_t mRegCertDataLisParam;
    //uint8_t *ptr8 = (uint8_t *)(&NRF_FICR->DEVICEID[0]);
    uint32_t err_code;

    uint16_t hRev, lRev;
    char bufDest[40];
    
    memset(&mDisInitParam, 0, sizeof(ble_dis_init_t));
    
    ble_srv_ascii_to_utf8(&mDisInitParam.manufact_name_str, PEDO_MANU_FACT_NAME_STR);


    if(Check_Fireware_Crc(&hRev, &lRev) == TRUE)
    {
        sprintf(bufDest, "%d.%d", hRev, lRev);
    }
    else
    {
        sprintf(bufDest, "0.0");
    }

    ble_srv_ascii_to_utf8(&mDisInitParam.fw_rev_str, bufDest);
    ble_srv_ascii_to_utf8(&mDisInitParam.hw_rev_str, PEDO_HW_REV_STR);  


    BLE_GAP_CONN_SEC_MODE_SET_OPEN(&mDisInitParam.dis_attr_md.read_perm);
    BLE_GAP_CONN_SEC_MODE_SET_NO_ACCESS(&mDisInitParam.dis_attr_md.write_perm);    

    err_code = ble_dis_init(&mDisInitParam);
    APP_ERROR_CHECK(err_code);
}
#endif

NrfPacInteface_t *GetNrfPacInterface(void *param)
{
    if(param != NULL)
    {
        NrfPacInteface_t *mInterface = (NrfPacInteface_t *)param;
        NrfPacHal_t *pNrfPacHal = (NrfPacHal_t *)param;
        
        memset(pNrfPacHal, 0, sizeof(NrfPacHal_t));
			
        pNrfPacHal->mIoState = IO_STATE_CLOSED;
        
        mInterface->IoTimeOutProcess = &NRF_PAC_IO_TimeOutProcess;
        mInterface->GetIoType  = &NRF_PAC_IO_TYPE;
        mInterface->GetIoState = &NRF_GET_PAC_IO_STATE;
        mInterface->IapIoSend = &NRF_PAC_IAP_IO_SEND;
        mInterface->SetIoState = &SET_NRF_PAC_IO_STATE;
        mInterface->GetIapReceiveState = &GET_NRF_PAC_IAP_RECEIVE_STATE;
        mInterface->ClearIapReceiveState = &CLEAR_NRF_PAC_IAP_RECEIVE_STATE;
#if !defined(_DISABLE_OBJECT_INTERFACE)          
        mInterface->UpdatePedometerDatas = &gNrfPacUpdatePedometerDatas;
        mInterface->UpdateCameraState = &gNrfPacUpdateCameraState;
        mInterface->SendNotify = &gNrfPacSendNotify;
        mInterface->GetCameraState = &gNrfPacGetCameraState;
        mInterface->TouchTheCamera = &gNrfPacTouchTheCamera;

        mInterface->ProximityAlateProcess = &gNrfPacProximityAlateProcess;
#endif        
        
        pNrfPacHal->mConnHandle = BLE_CONN_HANDLE_INVALID;   
#if !defined(_DISABLE_BOND)
        bond_manager_init(pNrfPacHal);	
#endif
        nrf_pac_ble_stack_init(pNrfPacHal);
        nrf_pac_gap_params_init(pNrfPacHal);
				
        nrf_pac_advertising_init(pNrfPacHal, BLE_GAP_ADV_FLAGS_LE_ONLY_LIMITED_DISC_MODE);
#if !defined(_DISABLE_NRF_PAC)        
        nrf_pac_services_init(pNrfPacHal);   
#endif
        nrf_pac_conn_params_init(pNrfPacHal);
        nrf_pac_sec_params_init(pNrfPacHal);
        
#if !defined(_DISABLE_DIS_SERVICE)
        nrf_pac_dis_service_init(pNrfPacHal);
#endif				

#if !defined(_DISABLE_PROXIMITY_SERVICE)
        nrf_proximity_services_init(pNrfPacHal);
#endif

#if !defined(_DISABLE_BOND)
        radio_notification_init(pNrfPacHal);
#endif
        return mInterface;
    }
    else
    {
        return (NrfPacInteface_t *)&gNrfPacHal;
    }

}



